/*
 * Copyright (c) 2013, Sangoma Technologies
 * James Zhang <jzhang@sangoma.com>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * * Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer.
 *
 * * Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in the
 * documentation and/or other materials provided with the distribution.
 *
 * * Neither the name of the original author; nor the names of any contributors
 * may be used to endorse or promote products derived from this software
 * without specific prior written permission.
 *
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER
 * OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <assert.h>

#define scci_assert(x) assert(x)

#define scci_assert_return(assertion, retval, msg) \
									if (!(assertion)) { \
										scci_assert(msg); \
										return retval; \
									}


#define SCCI_LOG(x, level, format, ...) (x.el_logger(__FILE__, __FUNCTION__, __LINE__, level, format, __VA_ARGS__))
#define SCCI_LOG_P(x, level, format, ...) ((x)->el_logger(__FILE__, __FUNCTION__, __LINE__, level, format, __VA_ARGS__))


#define SCCI_MAX_EVENTS_PER_SESSION     100
#define SCCI_MAX_EVENT_DATA_LEN         65535
#define SCCI_UUID_FORMATTED_LENGTH      256
#define SCCI_MAX_EVENT_PARAM_NUM        10000

