/*
 * Copyright (c) 2013, Sangoma Technologies
 * James Zhang <jzhang@sangoma.com>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * * Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer.
 *
 * * Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in the
 * documentation and/or other materials provided with the distribution.
 *
 * * Neither the name of the original author; nor the names of any contributors
 * may be used to endorse or promote products derived from this software
 * without specific prior written permission.
 *
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER
 * OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include "scci_def.h"


typedef enum scci_session_event_type {
    SCCI_EVENT_TYPE_FAIL,
    SCCI_EVENT_TYPE_INVALID
} scci_session_event_type_t;


typedef struct scci_event_param {
    char *str_key;
    char *str_val;
} scci_event_param_t;

struct scci_el_event{
    scci_session_event_type_t event_type;
    time_t event_time;
    char event_data[SCCI_MAX_EVENT_DATA_LEN];
    scci_event_param_t params[SCCI_MAX_EVENT_PARAM_NUM];
};
typedef struct scci_el_event scci_el_event_t;

typedef struct scci_event_listener_session {
    char scci_session_uuid[SCCI_UUID_FORMATTED_LENGTH + 1];
    char scci_peer_session_uuid[SCCI_UUID_FORMATTED_LENGTH + 1];

    scci_el_event_t events[SCCI_MAX_EVENTS_PER_SESSION]; /* answered, hangup, bridge .... */
    int event_count;

    scci_app_callback_handler_t cb_handlers;
} scci_el_session_t;


