/*
 * * Copyright (C) 2011, Sangoma Technologies.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Contributors:
 *
 *
 */

#include "scci_thread_declare.h"
#include "scci_thread.h"
#include "scci_mutex.h"


#ifndef _SCCI_QUEUE_H
#define _SCCI_QUEUE_H

typedef struct scci_queue {
	scci_mutex_t *mutex;
	scci_size_t	capacity; 
	scci_size_t	size;
	uint32_t rindex;
	uint32_t windex;
	void **elements;
}scci_queue_t;


scci_status_t scci_queue_create(scci_queue_t **outqueue, scci_size_t capacity);
scci_status_t scci_queue_destroy(scci_queue_t **inqueue);
scci_status_t scci_queue_enqueue(scci_queue_t *queue, void *obj);
void *scci_queue_dequeue(scci_queue_t *queue);
scci_bool_t scci_queue_empty(scci_queue_t *queue);


#endif /* _SCCI_QUEUE_H */

/* For Emacs:
 * Local Variables:
 * mode:c
 * indent-tabs-mode:t
 * tab-width:4
 * c-basic-offset:4
 * End:
 * For VIM:
 * vim:set softtabstop=4 shiftwidth=4 tabstop=4:
 */

/******************************************************************************/

